#!/bin/bash

######################################################################
# Build variables
######################################################################
ROOTDIR=`pwd`
SRCDIR=$ROOTDIR/src
BLDDIR=$ROOTDIR/build
RELDIR=$ROOTDIR/release
TESTDIR=$ROOTDIR/test
RESULTSDIR=$ROOTDIR/results
KERNEL_HDR=kernel_hdr

DATE=$(date +%Y-%m-%d)
GCCPATH=/opt/gnu/bin
QEMUPATH=$ROOTDIR/release/bin
PATH=$GCCPATH:$QEMUPATH:/usr/local/bin:/usr/bin:/bin

PROCESSORS=$(grep -c processor /proc/cpuinfo)
MAKE_JOBS=1
MAKE_JOBS=$(($PROCESSORS + 1))
MAKE="nice make"
SET_DATE=

######################################################################
#  Helper functions for the ubicom32 build script
#
######################################################################

usage()
{
    cat << EOF
usage: $0 <options> 

Builds the ubicom32 toolchain

OPTIONS:
   -h           Show this message
   -k <dir>     Explicity set the kernel source dir
   -c <dir>     Explicity set the uClibc source dir
   -f <file>    Load configuration from file.
   -d           Set gcc/gcc/DATESTAMP today
EOF
}


######################################################################

function Info() 
{
    echo "Info: " "$@"
}

function Status() 
{
    echo "------------------------------------------------------------"
    Info "$TARGET: $@"
    echo "------------------------------------------------------------"
}

######################################################################

function warn() 
{
    echo "Warning: $@" >&2
    echo "    in PWD=$PWD" >&2
}

function clean_up() 
{
# restore date stamp
    if [ "$CLEAN_UP_DATE" != "" ]; then
        rm $SRCDIR/gcc/gcc/DATESTAMP
        mv $CLEAN_UP_DATE $SRCDIR/gcc/gcc/DATESTAMP
    fi
}

######################################################################

function error_and_exit() {
    echo "Error: $@" >&2
    echo "    $TARGET in PWD=$PWD" >&2
    clean_up
    exit 1
}

######################################################################
# set_dir
#   changes the current dir to $BLDDIR/$1

function set_dir() 
{
    local DIR="$BLDDIR/$1"
    mkdir -p "$DIR"  || error_and_exit "Failed to mkdir dir=$DIR"
    cd "$DIR" || error_and_exit "Failed to cd dir=$DIR"
    Info "Set dir=$DIR"
}

######################################################################

function make_and_install() 
{
    Info "Build $PWD"
    NAME=$1
    rm -f $NAME_build_log.txt
    #rm -f build_log2.txt
    rm -f ${NAME}_install_log.txt
    Info "Logging to $PWD/${NAME}_build_log.txt"
    $MAKE -j$MAKE_JOBS > ${NAME}_build_log.txt 2>&1 || error_and_exit "Failed building"
    #Info "Logging to $PWD/${NAME}_build_log2.txt"
    #$MAKE  > ${NAME}_build_log2.txt 2>&1 || error_and_exit "Failed building"
    Info "Install $PWD"
    Info "Logging to $PWD/${NAME}_install_log.txt"
    $MAKE  install > ${NAME}_install_log.txt 2>&1 || error_and_exit "Failed installing"
}


######################################################################
# configure_and_build()

function configure_and_build()
{
    local NAME=$1; shift
    local DIR=$1; shift
    local SCRIPT=$1; shift

    Info "Configure in $DIR with $SCRIPT"
    set_dir $DIR

    Info "Running ...."

    echo "#  generated by configure_and_build" > reconfigure
    echo "export PATH=$PATH" >> reconfigure
    echo "export CFLAGS=\"-g -O2\"" >> reconfigure
    echo "export CXXFLAGS=\"-g -O2\"" >> reconfigure

    echo -n "$SCRIPT "  >> reconfigure
    for p in "$@"; do
        echo '\' >> reconfigure
        echo -n "     \"$p\" " >> reconfigure
    done
    echo >> reconfigure
    cat reconfigure
    chmod +x reconfigure
    Info "Logging to $PWD/${NAME}_configure_log.txt"
    ./reconfigure > $PWD/${NAME}_configure_log.txt || error_and_exit "Failed to configure"

    make_and_install $NAME

}

######################################################################
# set_target()
function set_target
{
    TARGET_ARCH=ubicom32
    TARGET_OS=$1
    TARGET=${TARGET_ARCH}-${TARGET_OS}
    CROSS_PREFIX=$RELDIR/$TARGET
    CROSS_RUNTIME=$CROSS_PREFIX/runtime
}

######################################################################
# configure_and_build_toolchain(name, dir, languages)
# builds the $TARGET tool chain in $TARGET-$1
function configure_and_build_toolchain()
{
    local NAME=$1; shift
    local languages=$1
    shift
    if [ "$languages" = "" ]; then
        $languages=c
    fi

    BUILD_CGEN=
    if $CONFIG_BUILD_CGEN; then
	BUILD_CGEN=--enable-cgen-maint
    fi

    Status "Build $languages Toolchain"

    # build toolchain
    configure_and_build $NAME $TARGET $SRCDIR/configure \
        --disable-werror \
        --enable-gdbmi \
        --enable-install-libbfd \
        --enable-languages=$languages \
        --enable-libada=no \
        --enable-libssp=no \
        --enable-rda=no \
	--with-x=no \
        --prefix=$RELDIR \
        --target=$TARGET \
        --with-gmp=$RELDIR \
        --with-mpfr=$RELDIR \
	$BUILD_CGEN \
        "$@"
}

######################################################################
function make_uClibc()
{
    local DESTDIR="$CROSS_RUNTIME"
    local DEVEL_PREFIX=/usr/
    local RUNTIME_PREFIX=/

    echo RUNNING: $MAKE -C "$UCLIBC_SRC" \
        ARCH_CFLAGS="$UCLIBC_CFLAGS" \
        DESTDIR="$DESTDIR" \
        DEVEL_PREFIX=$DEVEL_PREFIX \
        KERNEL_HEADERS="$KERNEL_HEADERS" \
        MULTILIB="$MULTILIB_DIR" \
        RUNTIME_PREFIX=$RUNTIME_PREFIX \
        UCLIBC_EXTRA_CFLAGS="$UCLIBC_EXTRA_CFLAGS" \
        V=1 \
        CROSS="$CROSS_COMPILE" \
        "$@" >&2

    # todo... test with job server
    $MAKE -C "$UCLIBC_SRC" \
        CROSS="$CROSS_COMPILE" \
        RUNTIME_PREFIX=$RUNTIME_PREFIX \
        ARCH_CFLAGS="$UCLIBC_CFLAGS" \
        MULTILIB="$MULTILIB_DIR" \
        DEVEL_PREFIX="$DEVEL_PREFIX" \
        V=1 \
        KERNEL_HEADERS="$KERNEL_HEADERS" \
        DESTDIR="$DESTDIR" \
        UCLIBC_EXTRA_CFLAGS="$UCLIBC_EXTRA_CFLAGS" \
        "$@" 2>&1 \
        || error_and_exit "Issue building uClibc $@"
}

######################################################################

function build_and_install_uClibc()
{
    MULTILIB_DIR="$1"; shift
    KERNEL_HEADERS="$BLDDIR/$KERNEL_HDR/usr/include"
    UCLIBC_EXTRA_CFLAGS="$@"

    Status "Build uClibc $MULITILIB_DIR , and CFLAGS=$@"
    set_dir logs/$TARGET/uClibc
    mkdir -p "$CROSS_RUNTIME"
    mkdir -p log_$MULTILIB_DIR

    # assume that $TARGET.config is in uClibc\
    cp $UCLIBC_SRC/$TARGET.config $UCLIBC_SRC/.config || error_and_exit "Couldn't copy $TARGET.config"
    find $UCLIBC_SRC -name "*.o" -exec rm {} \;
    make_uClibc clean > log_$MULTILIB_DIR/clean_log.txt || warn "Issue Cleaning uClibc"
    make_uClibc       > log_$MULTILIB_DIR/build_log.txt || error_and_exit "Building uClibc"

    Status "Install uClibc to $CROSS_RUNTIME"
    make_uClibc install > log_$MULTILIB_DIR/install_log_.txt
}

######################################################################

function build_and_install_uClibc_v5()
{
    MULTILIB_DIR="$1"; shift
    KERNEL_HEADERS="$BLDDIR/$KERNEL_HDR/usr/include"
    UCLIBC_EXTRA_CFLAGS="$@"

    Status "Build uClibc $MULITILIB_DIR , and CFLAGS=$@"
    set_dir logs/$TARGET/uClibc
    mkdir -p "$CROSS_RUNTIME"
    mkdir -p log_$MULTILIB_DIR

    # assume that $TARGET.config is in uClibc\
    cp $UCLIBC_SRC/$TARGET-v5.config $UCLIBC_SRC/.config || error_and_exit "Couldn't copy $TARGET.config"
    find $UCLIBC_SRC -name "*.o" -exec rm {} \;
    make_uClibc clean > log_$MULTILIB_DIR/clean_log.txt || warn "Issue Cleaning uClibc"
    make_uClibc       > log_$MULTILIB_DIR/build_log.txt || error_and_exit "Building uClibc"

    cp $UCLIBC_SRC/.config log_$MULTILIB_DIR/v5_config

    Status "Install uClibc to $CROSS_RUNTIME"
    make_uClibc install > log_$MULTILIB_DIR/install_log_.txt
}

######################################################################
# Install stripped libraries into sysroot direcotory
install_target_libs ()
{

    GCC=$RELDIR/bin/$TARGET-gcc
    TARGET_SHLIB=$($GCC --print-file-name=$1.so)
    if [ "$TARGET_SHLIB" == 0 ]; then
        return 0
    fi
    Info "Installing shared $1"

    MULTILIBS=`$GCC --print-multi-lib`

    for ml in $MULTILIBS; do

        dir=`echo ${ml} | sed -e 's/;.*$//'`
        flags=`echo ${ml} | sed -e 's/^[^;]*;//' -e 's/@/ -/g'`
        if [ "$dir" = "." ]; then
            dir2=
        else
            dir2=`echo ${dir} | sed -e 's|[^/]*|..|g'`/
        fi

        TARGET_SHLIB=$($GCC $flags --print-file-name=$1.so)
        TARGET_SHLIB=$(readlink -f $TARGET_SHLIB)
        TARGET_SHLIB_DIR=$(dirname $TARGET_SHLIB)
        TARGET_SHLIB_NAME=$(basename $TARGET_SHLIB)
        TARGET_SHLIB_VERSION=$(echo $TARGET_SHLIB_NAME | sed s/$1.so.'\([0-9]*.[0-9]*.[0-9]*\).*/\1/')
        MAJOR_NUM=$(echo $TARGET_SHLIB_VERSION | sed 's/\([0-9]*\).*/\1/')

        cp -fv $TARGET_SHLIB $CROSS_RUNTIME/lib/$dir
        $RELDIR/bin/$TARGET-strip -g $CROSS_RUNTIME/lib/$dir
        if [ "$MAJOR_NUM" != "" ]; then
            ln -sfv $TARGET_SHLIB_NAME $CROSS_RUNTIME/lib/$dir/$1.so.$MAJOR_NUM;
        fi

    done
}

######################################################################

function process_cmd_options() 
{
    while getopts "hdk:c:K:C:f:" OPTION
        do
            case $OPTION in
                h)
	            usage
	            exit 1
	            ;;
	        d)
	            CONFIG_SET_DATE=y
	            ;;
	        k)
	            CONFIG_KERNEL_SRC=$OPTARG
	            ;;
	        c)
	            CONFIG_UCLIBC_SRC=$OPTARG
	            ;;
	        f)
	            echo Loading Config from $OPTARG
	            source $OPTARG
	            ;;
	        ?)
	            usage
	            exit 1
	            ;;
            esac
        done
}

######################################################################

